/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the CreateMemberRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateMemberRequest{}

// CreateMemberRequest struct for CreateMemberRequest
type CreateMemberRequest struct {
	Email *string `json:"email,omitempty"`
}

// NewCreateMemberRequest instantiates a new CreateMemberRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateMemberRequest() *CreateMemberRequest {
	this := CreateMemberRequest{}
	return &this
}

// NewCreateMemberRequestWithDefaults instantiates a new CreateMemberRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateMemberRequestWithDefaults() *CreateMemberRequest {
	this := CreateMemberRequest{}
	return &this
}

// GetEmail returns the Email field value if set, zero value otherwise.
func (o *CreateMemberRequest) GetEmail() string {
	if o == nil || IsNil(o.Email) {
		var ret string
		return ret
	}
	return *o.Email
}

// GetEmailOk returns a tuple with the Email field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateMemberRequest) GetEmailOk() (*string, bool) {
	if o == nil || IsNil(o.Email) {
		return nil, false
	}
	return o.Email, true
}

// HasEmail returns a boolean if a field has been set.
func (o *CreateMemberRequest) HasEmail() bool {
	if o != nil && !IsNil(o.Email) {
		return true
	}

	return false
}

// SetEmail gets a reference to the given string and assigns it to the Email field.
func (o *CreateMemberRequest) SetEmail(v string) {
	o.Email = &v
}

func (o CreateMemberRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateMemberRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Email) {
		toSerialize["email"] = o.Email
	}
	return toSerialize, nil
}

type NullableCreateMemberRequest struct {
	value *CreateMemberRequest
	isSet bool
}

func (v NullableCreateMemberRequest) Get() *CreateMemberRequest {
	return v.value
}

func (v *NullableCreateMemberRequest) Set(val *CreateMemberRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateMemberRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateMemberRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateMemberRequest(val *CreateMemberRequest) *NullableCreateMemberRequest {
	return &NullableCreateMemberRequest{value: val, isSet: true}
}

func (v NullableCreateMemberRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateMemberRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
